/*
 * lang.h - Things lang.l and lang.y export
 *
 * Copyright 2012 by Werner Almesberger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */


#ifndef LANG_H
#define	LANG_H

#include "chr.h"
#include "subst.h"


extern const char *dollar; /* "$" */

extern struct action hierarchy;
extern struct subst *substitutions;

extern const char *file_name_override;

void parse_hierarchy(const char *name);
void parse_characteristics(const char *name);
void parse_inventory(const char *name);
void parse_currencies(const char *name);
void parse_providers(const char *name);
void parse_substitutions(const char *name);
void parse_kicad_bom(const char *name);
void parse_symbols(const char *name);

void yywarnf(const char *fmt, ...);
void yywarn(const char *s);
void __attribute__((noreturn)) yyerrorf(const char *fmt, ...);
void __attribute__((noreturn)) yyerror(const char *s);

#endif /* !LANG_H */
